
#include <future>
#include <iostream>

using namespace std;

#define N 1000000

int v[N];

// funzione di conteggio delle occorrenze di un valore
// in una sezione del vettore delimitata da due indici
int search(unsigned int begin, unsigned int end, int what)
{
	int count = 0;

	for (unsigned int i = begin; i < end; i++)
		if (v[i] == what)
			count++;
	return count;
}


int main(int argc, char* argv[])
{
	int what;
	unsigned int count = 0;
	
	// inizializzazione del vattore con valori casuali
	for (unsigned int i = 0; i < N; i++)
		v[i] = rand();
	//richiesta all'utente del valore da ricercare	
	cout << "Inserire il valore da ricercare: ";
	cin >> what;
	// creazione delloggetto future di tipo int
	// ricerca asinrona nella prima meta' del vettore
	future <int>result = async(&search, 0, N/2, what);
	// ricerca nella seconda meta' del vettore
	for (int i = N / 2; i < N; i++)
		if (v[i] == what)
			count++;
	// recupero e visualizzazione del risultato
	cout << "Trovati: " << count <<" + " << result.get() << " valori" << endl;
	return 0;
}