
#define CODE    0
#define DECODE	1

typedef unsigned char BYTE; // 8 bit
typedef unsigned short int WORD; // 16 bit


/*
	DES_encrypt codifica un blocco di 8 byte con algoritmo DES standard
	-> inp:	successione di 8 caratteri da cifrare
	-> psw:	password di cifratura/decifratura di 8 caratteri
	<- out:	successione di 8 caratteri cifrati
*/
void DES_encrypt(BYTE inp[8], BYTE out[8], BYTE psw[8]);

/*
	DES_decrypt decodifica un blocco di 8 byte codificati con algoritmo DES standard
	-> inp:	successione di 8 caratteri cifrati
	-> psw:	password di cifratura/decifratura di 8 caratteri
	<- out:	valori numerici degli 8 byte originali decifrati
*/
void DES_decrypt(BYTE inp[8], BYTE out[8], BYTE psw[8]);
